<template lang="html">
  <div :class="{'partner-quote': true, 'active': active, 'available': (kyc=='complete'||!kyc), 'incomplete': (kyc=='incomplete') }">
    <div class="exchange">
      <!-- <div class="caret">
        <butter-icon name="chevron-forward-outline"></butter-icon>
      </div> -->
      <span class="partner">
        <span class="partner-icon">
          <butter-icon v-if="name" :name="name" mode="logo" />
        </span>
        <div>
          <span class="partner-name" :class="[name && name.toLowerCase()]">{{ name }}</span>
          <span class="partner-delivery">{{ delivery }}</span>
        </div>
      </span>
      <div class="partner-amount">
        <span class="receive-amount-crypto"><butter-currency :value="receiveAmount" :currency="to" :precision="8" /></span>
        <span v-if="hasValue(receiveAmountConverted)" class="receive-amount-converted"><butter-currency :value="receiveAmountConverted" :precision="8"/></span>
      </div>
    </div>
    <div class="details">
      <span v-if="headnote" class="note headnote">{{ headnote }}</span>
      <span v-if="hasValue(fee)">
        <span class="details-title">Fee:</span>
        <butter-currency :value="fee" :currency="from" :trim="true" :precision="8" />
      </span>
      <span v-if="hasValue(networkFee)">
        <span class="details-title">Network Fee:</span>
        <butter-currency :value="networkFee" :currency="from" :trim="true" :precision="8" />
      </span>
      <div v-if="promotions.length" v-for="promotion in promotions" :class="promotion.class">
        <div class="details-title">
          <span>{{ promotion.label }}:</span>
          <span>{{ promotion.valueText }}</span>
        </div>
        <span v-if="promotion.note" class="more-details note">{{ promotion.note }}</span>
      </div>
      <span v-if="sendAmount">
        <span class="details-title">Total:</span>
        <butter-currency :value="sendAmount" :currency="from" :trim="true" :precision="8" />
      </span>
      <div class="more-details" v-if="footer">
        <span v-if="limitMin || limitMax">Limit: <butter-currency :value="limitMin" :currency="from" :trim="true" /> - <butter-currency :value="limitMax" :currency="from" :trim="true" /></span>
        <span v-if="documents && kyc=='incomplete'">Documents required: {{ documents }}</span>
        <span v-if="note || footnote" class="note">{{ note || footnote }}</span>
        <!-- <span v-if="kyc=='complete'">KYC Complete</span> -->
        <!-- <span v-if="kyc=='complete'||!kyc">Fast Checkout Available!</span> -->
      </div>
      <div v-if="settings" class="settings-button">
        <partner-settings @click="$emit('settings', settings)" label="Settings" />
      </div>
    </div>
    <slot></slot>
  </div>
</template>

<script>
function normalize(string) {
  return string.match(/[0-9\.]/g).join("");
}
export default {
  props: [
    'receiveAmount',
    'receiveAmountConverted',
    'sendAmount',
    'fee',
    'networkFee',
    'paymentMethod',
    'delivery',
    'name',
    'logo',
    'currencies',
    'limitMin',
    'limitMax',
    'active',
    'kyc',
    'documents',
    'from',
    'to',
    'settings',
    'promotions',
    'note',
    'headnote',
    'footnote'
  ],
  data() {
    return {};
  },
  methods: {
    hasValue(currency) {
      if(typeof currency === 'string' || typeof currency === 'number') return Number(normalize(currency)) > 0;
      return currency && Number(currency.numerator) > 0;
    },
  },
  computed: {
    footer() {
      return this.limitMin || this.limitMax || this.documents || this.note || this.footnote;
    },
  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';

.partner-quote {
  @include themify($themes) {
    background-color: themed('color-bg-primary');
    @include corners(themed('corner-radius'),themed('corner-radius'),themed('corner-radius'),themed('corner-radius'));
  }
  // Mixins
  // Box properties
  width: auto;
  position: relative;
  display: flex;
  flex-direction: column;
  flex-shrink: 0;
  margin: 0 $grid * 2 $grid * 4;
  // Background & borders
  // Typography
  // Animation
  // Other
}

.link-out {
  position: absolute;
  bottom: $grid;
  right:  $grid;
  transform: rotate(135deg);
  opacity: 0.7;
}

// .partner-quote {
//   display: flex;
//   flex-direction: column;
//   // background-color: $color-bg-secondary;
//   padding: $grid * 3 0 0;
//   border-top: 1px solid $border-color;
//
//   &.active {
//     // background-color: $color-bg-tertiary;
//   }
//   &.available {
//     // background-color: $color-bg-secondary;
//   }
//   &.active.available {
//     // background-color: $color-bg-secondary-light;
//     // color: $color-text-pimary-dark;
//     .more-details {
//       // background-color: $color-bg-secondary-light;
//
//     }
//   }
// }

.exchange {
  // Mixins
  // Box properties
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: flex-start;
  align-items: center;
  position: relative;
  padding: $grid * 2 $grid;
  // Background & borders
  // Typography
  // Animation
  // Other
}

.exchange > span {
  // Mixins
  // Box properties
  flex-grow: 1;
  // Background & borders
  // Typography
  // Animation
  // Other
}

.partner {
  display: flex;
  align-items: center;
}

.partner div {
  // Mixins
  // Box properties
  display: flex;
  flex-direction: column;
  justify-content: left;
  align-items: flex-start;
  position: relative;
  flex-grow: 2;
  // Background & borders
  // Typography
  // Animation
  // Other
}

.partner-icon {
  // Mixins
  // Box properties
  display: flex;
  align-items: center;
  padding: 0;
  margin: $grid;
  flex-grow: 0 !important;
  // Background & borders
  // Typography
  // Animation
  // Other
}

.partner-name {
  // Mixins
  // Box properties
  flex-grow: 2;

  // Background & borders
  // Typography
  font-family: $font-sans-bold;
  // Animation
  // Other
}

.partner-delivery {
  @include themify($themes) {
    color: themed('color-text-tertiary');
  }
  // Mixins
  // Box properties
  // Background & borders
  // Typography
  // Animation
  // Other
}

.partner-amount {
  // Mixins
  // Box properties
  display: flex;
  flex-direction: column;
  flex-grow: 1;
  justify-content: flex-end;
  align-items: flex-end;
  padding: 0 $grid;

  // Background & borders
  // Typography
  // Animation
  // Other
}

.receive-amount-crypto {
  // Mixins
  // Box properties
  // Background & borders
  // Typography
  font-family: $font-sans-bold;
  // Animation
  // Other
}

.receive-amount-converted {
  @include themify($themes) {
    color: themed('color-text-tertiary');
  }
  // Mixins
  // Box properties
  // Background & borders
  // Typography
  // Animation
  // Other
}

// span.simplex {
//   // Mixins
//   // Box properties
//   // Background & borders
//   background-color: #469b32;
//   // Typography
//   // Animation
//   // Other
// }
// span.wyre {
//   // Mixins
//   // Box properties
//   // Background & borders
//   background-color: #0055ff;
//   // Typography
//   // Animation
//   // Other
// }
// span.coinify {
//   // Mixins
//   // Box properties
//   // Background & borders
//   background-color: #f8b04a;
//   // Typography
//   // Animation
//   // Other
// }

.caret { // Temporary placeholder until we get the icons up in here
  @include themify($themes) {
    color: themed('color-text-tertiary');
  }
  // Mixins
  // Box properties
  position: absolute;
  top: $grid * 3.5;
  right: $grid;
  width: $grid * 4;
  height: $grid * 4;
  display: flex;
  align-items: center;
  justify-content: center;
  // Background & borders
  // Typography
  // Animation
  // Other
}
// .receive-amount-title {
//   display: flex;
//   flex-grow: 1;
//   justify-content: center;
//   color: $color-text-tertiary;
// }
// .receive-amount-crypto {
//   display: flex;
//   flex-grow: 1;
//   justify-content: center;
//   margin-bottom: 0;
//   margin-top: 0;
//   line-height: $font-size-h1;
// }
//
// .receive-amount-converted {
//   display: flex;
//   flex-grow: 1;
//   justify-content: center;
//   color: $color-text-tertiary;
// }
.details {
  display: flex;
  flex-grow: 2;
  flex-direction: column;
}

.details-title {
  @include themify($themes) {
    color: themed('color-text-tertiary');
  }
  // Mixins
  // Box properties
  // Background & borders
  // Typography
  font-family: $font-sans;
  // Animation
  // Other
}

.details > span,
.details .promotion .details-title {
  @include themify($themes) {
    border-top: 1px solid themed('border-color');
  }
  // Mixins
  // Box properties
  padding: $grid $grid * 2;
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  align-items: center;
  justify-content: space-between;
  // Background & borders
  // Typography
  font-family: $font-sans-bold;
  // Animation
  // Other
}

.details .promotion .details-title {
  overflow: hidden;
  padding: 0;

  span {
    background: -webkit-gradient(linear, left top, right top, from(#FF5193), to(#F29500));
    -webkit-background-clip: text;
    background-clip: text;
    color: transparent;
    flex-direction: column;
    display: block;
    padding: $grid $grid * 2;
    margin: 0 0 -1px -1px;
  }
}

.note {
  @include themify($themes) {
    color: themed('color-text-tertiary');
  }
  // Mixins
  @include font(12px,16px,$font-sans);
  // Typography

  &.headnote {
    border-top: 0;
  }
}

.more-details {
  @include themify($themes) {
    border-top: 1px solid themed('border-color');
  }
  // Mixins
  // Box properties
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: space-between;
  padding: $grid $grid*2;
  margin: 0;
  // Background & borders
  // Typography
  // Animation
  // Other
  .promotion & {
    border-top: 0;
  }
}

.settings-button {
  @include themify($themes) {
    border-top: 1px solid themed('border-color');
  }
  // Mixins
  @include font(12px,16px,$font-sans);
  // Box properties
  margin: 0;
  padding: $grid 0;
  display: flex;
  align-items: center;
  justify-content: center;
  // Background & borders
}


</style>
